var __require = /* @__PURE__ */ ((x) => typeof require !== "undefined" ? require : typeof Proxy !== "undefined" ? new Proxy(x, {
  get: (a, b) => (typeof require !== "undefined" ? require : a)[b]
}) : x)(function(x) {
  if (typeof require !== "undefined")
    return require.apply(this, arguments);
  throw Error('Dynamic require of "' + x + '" is not supported');
});

// src/router.ts
import { remove } from "zhin";
import { WebSocketServer } from "ws";
import { parse } from "url";
var KoaRouter = __require("@koa/router");
var Router = class extends KoaRouter {
  //用于historyApi排除
  constructor(server, options) {
    super(options);
    this.server = server;
    this.wsStack = [];
    this.whiteList = [];
  }
  register(...args) {
    const path = args[0];
    this.whiteList.push(path);
    return super.register(...args);
  }
  destroy(layer) {
    remove(this.stack, layer);
  }
  destroyWs(wsServer) {
    wsServer.close();
    remove(this.wsStack, wsServer);
  }
  ws(path, options = {}) {
    const wsServer = new WebSocketServer({
      noServer: true,
      path,
      ...options
    });
    this.wsStack.push(wsServer);
    this.server.on("upgrade", (request, socket, head) => {
      const { pathname } = parse(request.url);
      if (this.wsStack.findIndex((wss) => wss.options.path === path) === -1) {
        socket.destroy();
      } else if (pathname === path) {
        wsServer.handleUpgrade(request, socket, head, (ws) => {
          wsServer.emit("connection", ws, request);
        });
      }
    });
    return wsServer;
  }
};

export {
  Router
};
