"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  Router: () => Router,
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);
var import_zhin2 = require("zhin");
var import_http = require("http");
var import_koa = __toESM(require("koa"));
var import_koa_basic_auth = __toESM(require("koa-basic-auth"));
var import_koa_bodyparser = __toESM(require("koa-bodyparser"));

// src/router.ts
var import_zhin = require("zhin");
var import_ws = require("ws");
var import_url = require("url");
var KoaRouter = require("@koa/router");
var Router = class extends KoaRouter {
  //用于historyApi排除
  constructor(server2, options) {
    super(options);
    this.server = server2;
    this.wsStack = [];
    this.whiteList = [];
  }
  register(...args) {
    const path = args[0];
    this.whiteList.push(path);
    return super.register(...args);
  }
  destroy(layer) {
    (0, import_zhin.remove)(this.stack, layer);
  }
  destroyWs(wsServer) {
    wsServer.close();
    (0, import_zhin.remove)(this.wsStack, wsServer);
  }
  ws(path, options = {}) {
    const wsServer = new import_ws.WebSocketServer({
      noServer: true,
      path,
      ...options
    });
    this.wsStack.push(wsServer);
    this.server.on("upgrade", (request, socket, head) => {
      const { pathname } = (0, import_url.parse)(request.url);
      if (this.wsStack.findIndex((wss) => wss.options.path === path) === -1) {
        socket.destroy();
      } else if (pathname === path) {
        wsServer.handleUpgrade(request, socket, head, (ws) => {
          wsServer.emit("connection", ws, request);
        });
      }
    });
    return wsServer;
  }
};

// src/index.ts
var process = __toESM(require("process"));
var koa = new import_koa.default();
var username = process.env.username || "admin";
var password = process.env.password || "123456";
koa.use(
  (0, import_koa_basic_auth.default)({
    name: username,
    pass: password
  })
);
var server = (0, import_http.createServer)(koa.callback());
var router = new Router(server, { prefix: process.env.routerPrefix || "" });
var outputCommand = (command) => {
  return {
    name: command.name,
    desc: command.config.desc,
    alias: command.aliasNames,
    hidden: command.config.hidden,
    help: command.help()
  };
};
router.get("/api/plugins", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = httpServer.app.pluginList.map((plugin) => {
    return {
      full_name: plugin.name,
      display_name: plugin.display_name,
      status: plugin.status,
      middlewareCount: plugin.middlewares.length,
      commands: [...plugin.commands.values()].map(outputCommand),
      services: [...plugin.services.entries()].map(([name]) => name)
    };
  });
});
router.get("/api/plugin/:name/commands", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = [...httpServer.app?.plugins.get(ctx.params.name)?.commands.values() || []].map(outputCommand);
});
router.get("/api/config", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = httpServer.app.config;
});
router.get("/api/adapters", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = [...httpServer.app.adapters.values()].map((adapter) => {
    return {
      name: adapter.name,
      bots: adapter.bots.map((bot) => {
        return bot.unique_id;
      })
    };
  });
});
router.get("/api/adapter/:name/bots", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = httpServer.app?.adapters.get(ctx.params.name)?.bots.map((bot) => {
    return bot.unique_id;
  }) || [];
});
router.get("/api/bots", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = [...httpServer.app?.adapters.values() || []].reduce((result, adp) => {
    return result.concat(
      adp.bots.map((bot) => {
        return bot.unique_id;
      })
    );
  }, []);
});
router.get("/api/commands", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = [...httpServer.app.commandList].map(outputCommand);
});
var httpServer = new import_zhin2.Plugin("http-server");
httpServer.service("server", server).service("koa", koa).service("router", router);
koa.use((0, import_koa_bodyparser.default)()).use(router.routes()).use(router.allowedMethods());
var _a;
server.listen(
  {
    host: "0.0.0.0",
    port: Number((_a = process.env).port || (_a.port = "8086"))
  },
  () => {
    const address = server.address();
    if (!address)
      return;
    httpServer.app?.logger.mark("server start at", address);
    httpServer.app?.logger.info("your username is\uFF1A", username);
    httpServer.app?.logger.info("your password is\uFF1A", password);
  }
);
httpServer.on("plugin-beforeUnmount", () => {
  server.close();
});
var src_default = httpServer;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Router
});
