import {
  Router
} from "./chunk-D6BKO72E.mjs";

// src/index.ts
import { Plugin } from "zhin";
import { createServer } from "http";
import Koa from "koa";
import auth from "koa-basic-auth";
import KoaBodyParser from "koa-bodyparser";
import * as process from "process";
var koa = new Koa();
var username = process.env.username || "admin";
var password = process.env.password || "123456";
koa.use(
  auth({
    name: username,
    pass: password
  })
);
var server = createServer(koa.callback());
var router = new Router(server, { prefix: process.env.routerPrefix || "" });
var outputCommand = (command) => {
  return {
    name: command.name,
    desc: command.config.desc,
    alias: command.aliasNames,
    hidden: command.config.hidden,
    help: command.help()
  };
};
router.get("/api/plugins", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = httpServer.app.pluginList.map((plugin) => {
    return {
      full_name: plugin.name,
      display_name: plugin.display_name,
      status: plugin.status,
      middlewareCount: plugin.middlewares.length,
      commands: [...plugin.commands.values()].map(outputCommand),
      services: [...plugin.services.entries()].map(([name]) => name)
    };
  });
});
router.get("/api/plugin/:name/commands", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = [...httpServer.app?.plugins.get(ctx.params.name)?.commands.values() || []].map(outputCommand);
});
router.get("/api/config", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = httpServer.app.config;
});
router.get("/api/adapters", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = [...httpServer.app.adapters.values()].map((adapter) => {
    return {
      name: adapter.name,
      bots: adapter.bots.map((bot) => {
        return bot.unique_id;
      })
    };
  });
});
router.get("/api/adapter/:name/bots", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = httpServer.app?.adapters.get(ctx.params.name)?.bots.map((bot) => {
    return bot.unique_id;
  }) || [];
});
router.get("/api/bots", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = [...httpServer.app?.adapters.values() || []].reduce((result, adp) => {
    return result.concat(
      adp.bots.map((bot) => {
        return bot.unique_id;
      })
    );
  }, []);
});
router.get("/api/commands", (ctx) => {
  ctx.response.headers["Content-Type"] = "application/json";
  ctx.body = [...httpServer.app.commandList].map(outputCommand);
});
var httpServer = new Plugin("http-server");
httpServer.service("server", server).service("koa", koa).service("router", router);
koa.use(KoaBodyParser()).use(router.routes()).use(router.allowedMethods());
var _a;
server.listen(
  {
    host: "0.0.0.0",
    port: Number((_a = process.env).port || (_a.port = "8086"))
  },
  () => {
    const address = server.address();
    if (!address)
      return;
    httpServer.app?.logger.mark("server start at", address);
    httpServer.app?.logger.info("your username is\uFF1A", username);
    httpServer.app?.logger.info("your password is\uFF1A", password);
  }
);
httpServer.on("plugin-beforeUnmount", () => {
  server.close();
});
var src_default = httpServer;
export {
  Router,
  src_default as default
};
